<template>
  <v-form @submit.prevent="editDepartment">
    <v-container>
      <v-row>
        <v-col>
          <h2>Abteilung: ({{department}})</h2>

          <v-text-field
              v-model="departmentToEdit.departmentName"
              label="Abteilung">
          </v-text-field>

          <v-btn
              color="green-darken-3"
              block
              class="me-4"
              type="submit">Bestätigen</v-btn>

        </v-col>
      </v-row>
    </v-container>
  </v-form>
</template>

<script setup>
import {onMounted, ref, watch} from "vue";
import {useDepartmentStore} from "@/stores/departmentStore";

//STORE
const departmentStore = useDepartmentStore();

//PROPS
const props = defineProps(["department"]);

//VARIABLES
const departmentToEdit = ref({
  departmentName: ""
});

//LIFECYCLEHOOK
onMounted(async () => {
  await departmentStore.getDepartments();
})

//WATCHER
watch(() => props.department, (newDepartment) => {
  if (newDepartment) {
    departmentToEdit.value.departmentName = newDepartment
  }
}, { immediate: true });

//FUNCTIONS
async function editDepartment() {
  try {
        await departmentStore.updateDepartment(props.department, departmentToEdit.value)
        await departmentStore.getDepartments();
  } catch (error) {
    alert("Etwas ist schief gelaufen.")
    console.log("error", error)
  }
}
</script>

<style scoped>
</style>